
#include <iostream>
#include "functions.h"


int main (int argc, char *argv[]){




 cout<<" >>>>>>>>>>> \n Pardiff arguments:	<expression threshold>,  <fold level>,  <condition1> <folder1>  [<condition2>  <folder2>]  [strand] [chromosome] "<<endl;

    string folder1, org1,initstrand="all", initchrom="genome",foldero;
    string org2, folder2;

    map <string, unsigned int>  chroms;
    map <string, unsigned int>:: iterator itercrom;
    vector<string> strands;
    vector<string>::iterator iterstr;
    float elimit, foldlimit;
    string elimit_string, foldlimit_string;

    if(argc==4) {
        cout<<argc<< " arguments entered."<<"\n"<<"You will reconstruct transcribed regions from the expression probability profile"<<endl;
        istringstream iss(argv[1]);iss >> elimit; elimit_string=string(argv[1]);
        org1=string(argv[2]);
        folder1=string(argv[3]);
    }

    if(argc==7) {
        istringstream iss(argv[1]);iss >> elimit; elimit_string=string(argv[1]);
        istringstream iss2(argv[2]);iss2 >> foldlimit; foldlimit_string=string(argv[2]);
        org1=string(argv[3]);
        folder1=string(argv[4]);
        org2=string(argv[5]);
        folder2=string(argv[6]);
    }
    if(argc==9) {
        istringstream iss(argv[1]);iss >> elimit; elimit_string=string(argv[1]);
        istringstream iss2(argv[2]);iss2 >> foldlimit; foldlimit_string=string(argv[2]);
        org1=string(argv[3]);
        folder1=string(argv[4]);
        org2=string(argv[5]);
        folder2=string(argv[6]);
        initstrand=string(argv[7]);
        initchrom=string(argv[8]);
    }


float penal=0.05,penaltrans=0.2;
//    folder1="/media/storage/DATA/Parseq/candida1";
//    folder2="/media/storage/DATA/Parseq/candida";
//    foldero="/media/storage/DATA/Parseq/candida_candida1";
//     org1="candida1";
//    org2="candida";
//    initstrand="-";
//    initchrom="Ca21chr5_C_albicans_SC5314";
//    elimit=0.05; elimit_string="0.05";
//    foldlimit=2; foldlimit_string="2";


    if(initstrand=="all") {strands.push_back("+");strands.push_back("-");}
    else  strands.push_back(initstrand);
    if(initchrom=="genome")
        chroms=get_chromosomes(folder1,org1);
    else
        chroms[initchrom]=get_chromosomes(folder1,org1)[initchrom];

    bool firstflag;
    if (argc==4) {
        foldero=folder1+"/results/";
        cout<<"Wrinting  in: "<<foldero<<endl;

        for(iterstr=strands.begin();iterstr!=strands.end();iterstr++){
            firstflag=true;
            for (itercrom=chroms.begin();itercrom!=chroms.end();itercrom++){
                cout<<"Wrinting chromosome: "<<(*itercrom).first<<" on strand: "<< *iterstr<<endl;

                float* trans1=read_expression(folder1,org1,"Trans",itercrom,iterstr,elimit_string);

                construct_regions(trans1,(*itercrom).second , penaltrans, foldero,"transcripts", org1,"NO", *iterstr,(*itercrom).first,firstflag);
                cout<<"Done: "<<(*itercrom).first<<" on strand: "<< *iterstr<<endl;
                firstflag=false;
            }
        }
    }
    if(argc>=5) {
        foldero=folder1+"_"+org2;
        cout<<"Wrinting  in: "<<foldero<<endl;
        system(("if [ ! -d \""+foldero+"\" ]; then mkdir "+foldero+"; fi").c_str());
        for(iterstr=strands.begin();iterstr!=strands.end();iterstr++){
            firstflag=true;
            for (itercrom=chroms.begin();itercrom!=chroms.end();itercrom++){


                cout<<*iterstr<<" "<<(*itercrom).first<<" "<<(*itercrom).second<<endl;
                float* exp1=read_expression(folder1,org1,"Expression",itercrom,iterstr,elimit_string);
                float* exp2=read_expression(folder2,org2,"Expression",itercrom,iterstr,elimit_string);
                float* trans1=read_expression(folder1,org1,"Trans",itercrom,iterstr,elimit_string);
                float* trans2=read_expression(folder2,org2,"Trans",itercrom,iterstr,elimit_string);
                float* proba= compute_fold(exp1, exp2, (*itercrom).second, elimit, foldlimit, foldero, org1, org2, *iterstr,(*itercrom).first,firstflag);
    //            cout<<"trans1: "<<trans1[(*itercrom).second-418000]<<endl;
                construct_regions(proba,(*itercrom).second , penal, foldero,"DE", org1, org2, *iterstr,(*itercrom).first,firstflag);
                construct_regions(trans1,(*itercrom).second , penaltrans, foldero,"transcripts", org1,"NO", *iterstr,(*itercrom).first,firstflag);
                construct_regions(trans2,(*itercrom).second , penaltrans, foldero,"transcripts", org2,"NO", *iterstr,(*itercrom).first,firstflag);
                firstflag=false;

            }
        }
    }
return 0;
}
