
#ifndef DATA_H_
#define DATA_H_

# include <sstream>
# include <iostream>
# include <fstream>
# include <map>
# include <string>
# include <stdio.h>
# include <stdlib.h>
# include <vector>
# include <math.h>
using namespace std;

map <string, unsigned int> get_chromosomes(string folder,string org_name);

float *	read_expression(string folder, string org_name,string data_type, map<string,unsigned int >::iterator crom, vector<string>::iterator strand,string elimit_string);
float * compute_fold(float* exp1,float* exp2, size_t LEN,float elimit,float foldlimit,string folder,string org1, string org2,string strand,string crom,bool firstflag);

vector< pair< pair<int,int>, float> > construct_regions(float * x, int T, float penal,string folder,string data_type,string org1, string org2,string strand,string crom,bool flag);


#endif /* DATA_H_ */
